"""
 <Von Stiften und Musen>
 Eine neue Portierung fr Python, entstanden im Rahmen meiner Diplomarbeit.

 Klasse Bildschirm von SuM

 erste Vers: 21.01.2002
 Version...: 03.03.2003
 Status....: OK.
 Autor.....: i.linkweiler@gmx.de
"""

# Importiere benutze Module
import sumwrapper

#global _SCREEN

################################################
# Bildserver
################################################

class Bildschirm:
  """
   Ein Bildschirm ist das Modell eines rechteckigen Bereiches auf dem
   angeschlossenen Computerbildschirm.
   Auf ihm kann mit Stiften gezeichnet werden. Zu diesem Zweck ist die 
   Zeichenebene auf dem Bildschirm mit einem Koordinatensystem versehen, 
   dessen Ursprung sich in der oberen linken Ecke der Zeichenebene befindet
   und dessen Achsen horizontal nach rechts und vertikal nach unten 
   gerichtet sind. Die Einheit ist ein Pixel.
  """

  ### EXTERNE METHODEN ###
  def __init__(self,hintergrundbild=""):
      self.bild=sumwrapper.Bildserver(hintergrundbild)   
      """
      Konstruktor, der Bildschirm wird initialisiert.
      'hintergrundbild' ist ein optionaler Dateiname einer Grafikdatei als Bildschirmhintergrund.    
      """

  def __del__(self):
      "intern: Destruktor, nur zur Sicherheit"
      self.bild.ende()
      
  def breite(self):
      "liefert die breite der Zeichenebene"
      return self.bild.breite()

  def hoehe(self):
      "liefert die hoehe der Zeichenebene"
      return self.bild.hoehe()

  def loescheAlles(self):
      "loescht die Zeichenebene"   
      self.bild.loescheAlles()

  def setzeHintergrund(self,dateiname):
      "Lade einen Hintergrund und zeige diesen im Fenster."
      self.bild.setzeHintergrund(dateiname)
      
  def gibFrei(self):
      "Das Ausgabefenster wird abgebaut."
      self.bild.gibFrei()
      
def main():
    "Testprogramm."
    bild=Bildschirm()
    bild.loescheAlles()
    bild.gibFrei()
        
# call the "main" function if running this script
if __name__ == '__main__': main()
