"""
 Beispiel: Definition einer Klasse Waggon,
 daraus werden spezialisierte Klassen Gueterwagen und Personenwagen abgeleitet.

 Jeder Waggon hat nun ein Attribut Nachfolger.
 Die Methode "bewege_um" bewegt den Wagen selbst, und seinen Nachfolger.
 Es muss nun nur noch die Lok bewegt werden.
 Die Methode "Kopple_an" teilt dem Vorgnger den Nachfolger mit (Verkettung)

 (Hier wird die Klasse Sprite genutzt, um die Zeichenmethoden einzusparen.)
"""

from sum import *

# Definition eines allgemeinen Waggons
class Waggon:
  def __init__(self):
    self.hPosition=100
    self.vPosition=100
    self.bild=Sprite("wagen-leer.bmp",bildschirm)
    self.nachfolger=None
  
  def bewegeBis(self,xneu,yneu):
    self.hPosition=xneu
    self.vPosition=yneu
    self.bild.bewegeBis(self.hPosition,self.vPosition) 
  
  def gibFrei(self):
    pass

  def bewegeUm(self,laenge):
    # mich bewegen
    self.hPosition=self.hPosition+laenge   
    # mich zeichnen
    self.bild.bewegeBis(self.hPosition,self.vPosition) 

    # Wenn es einen Nachfolger gibt, diesem eine Nachricht senden.
    if self.nachfolger<>None:
      self.nachfolger.bewegeUm(laenge)
  
  def koppelan(self,vorgaenger):
    self.hPosition = vorgaenger.hPosition - 40
    self.bild.bewegeBis(self.hPosition,self.vPosition) 
    
    # Dem Vorgaenger mitteilen, das wir selbst sein Nachfolger sind.
    vorgaenger.nachfolger=self
  
  def zeichne(self):
    # Einen Waggon an der aktuellen x/y-Position zeichnen
    self.bild.bewegeBis(self.hPosition,self.vPosition) 

class Gueterwagen(Waggon):
  def __init__(self):
    self.hPosition=100
    self.vPosition=100
    self.bild=Sprite("wagen-gueter.bmp",bildschirm)
  
class Personenwagen(Waggon):
  def __init__(self):
    self.hPosition=100
    self.vPosition=100
    self.bild=Sprite("wagen-person.bmp",bildschirm)

class Lok(Waggon):
  def __init__(self):
    self.hPosition=100
    self.vPosition=100
    self.bild=Sprite("lok.bmp",bildschirm)
    
# Erzeuge Bildschirm und Maus
bildschirm=Bildschirm()
maus=Maus(bildschirm)
tastatur=Tastatur(bildschirm)

# Erzeuge Lok und einige Waggons.
lok=Lok()
lok.bewegeBis(200,100)

w1=Personenwagen()
w1.koppelan(lok)

w2=Personenwagen()
w2.koppelan(w1)

w3=Gueterwagen()
w3.koppelan(w2)

w4=Waggon()
w4.koppelan(w3)

# Ball bewegen bis Mausklick
while not maus.doppelKlick():
  lok.bewegeUm(1)
     
# Und Ende.
tastatur.gibFrei()
maus.gibFrei()
bildschirm.gibFrei()
