"""
 Beispiel: Huhn-Jagd - Das lustige Hhner-Spiel...
"""

from sum import *
import random      
      
class Huhn(Sprite):
    """
     Huhn bewegt ein fliegendes Huhn ber den Bildschirm
     Es erbt alle Methoden von Sprite
    """

    def startwerte(self):
      # Setze das Huhn an die Startposition und lege die Bewegung fest
      self.xBewegung=random.randrange(1,5)
      self.yBewegung=random.randrange(-2,2)
      self.bewegeBis( random.randrange(-40,0), random.randrange(20,300) )
          
    def fliegen(self):
      # Bewege das Huhn in x und y-Richtung.
      xneu=self.hPosition()+self.xBewegung
      if xneu>660: xneu=0     
      yneu=self.vPosition()+self.yBewegung
      if yneu>480 or yneu<0:
        self.startwerte()     
      else:
        self.bewegeBis(xneu,yneu)
    
    def getroffen(self):
      # Das Huhn wurde getroffen und fllt....
      self.yBewegung=20
      

class Spiel:
  def __init__(self):
    # Erzeuge die ntigen Objekte
    self.win=Bildschirm("landschaft.jpg")

    self.huehnerliste=[]
    for i in range(10):
      huhn1 = Huhn("huhn1.bmp") 
      huhn1.startwerte()
      huhn2 = Huhn("huhn2.bmp") 
      huhn2.startwerte()
      self.huehnerliste.append(huhn1)
      self.huehnerliste.append(huhn2)   

    self.fadenkreuz=Sprite("fadenkreuz.bmp")
    
    self.tast=Tastatur()
    self.maus=Maus()
    self.stift=Buntstift()
    
    self.treffer=0
    
    # Ein wenig schreiben...
    self.stift.schreibe("(Q) zum Beenden.")
    self.stift.setzeSchriftGroesse(30)
    
    # Eine Steuerung per Maus
    self.beenden=0

  def gibPunkte(self):
    # Punkte +1 und ausgeben
    self.stift.radiere()
    self.stift.bewegeBis(410,10)
    self.stift.schreibe(self.treffer)           
    
    self.treffer=self.treffer+1
    self.stift.normal()
    self.stift.bewegeBis(410,10)
    self.stift.schreibe(self.treffer)           


  def start(self):  
    # Spiel starten
    while not self.beenden:
      self.fadenkreuz.bewegeBis(self.maus.hPosition(),self.maus.vPosition())     
      for h in self.huehnerliste:
        h.fliegen()

      if self.maus.istGedrueckt ():
        for h in self.huehnerliste:
         if h.kollidiert(self.fadenkreuz):
           h.getroffen()          

           self.gibPunkte()

      if self.tast.wurdeGedrueckt():
        if self.tast.zeichen()=="q":
          self.beenden=1
    # ende der While-Schleife
   
  def gibFrei(self):
    # alles Freigeben
    self.maus.gibFrei()
    self.stift.gibFrei()
    self.win.gibFrei()


# Erzeuge und starte das Spiel
spiel=Spiel()
spiel.start()
spiel.gibFrei()